CGAL 6.2 - 3D Triangulations: CGAL::Regular_triangulation_cell_base_with_weighted_circumcenter_3< Traits, Cb > Class Template Reference

CGAL 6.2 - 3D Triangulations

Loading...
Searching...
No Matches
List of all members
CGAL::Regular_triangulation_cell_base_with_weighted_circumcenter_3< Traits, Cb > Class Template Reference
Reference Manual » Vertex and Cell Classes

`#include <CGAL/Regular_triangulation_cell_base_with_weighted_circumcenter_3.h>`

## Inherits from

Cb.

## Definition

template<typename Traits, typename Cb>
class CGAL::Regular_triangulation_cell_base_with_weighted_circumcenter_3< Traits, Cb >

The class `Regular_triangulation_cell_base_with_weighted_circumcenter_3` derives from `Cb`, a cell base class of a 3D triangulation.

It provides an easy way to cache the computation of the weighted circumcenters of tetrahedra. Note that input/output stream operators discard this additional information.

All functions modifying the vertices of the cell invalidate the cached circumcenter.

Template Parameters

  Traits | is the geometric traits class and must be a model of `RegularTriangulationTraits_3`.
  Cb | is a cell base class from which `Regular_triangulation_cell_base_with_weighted_circumcenter_3` derives. Cb must be a model of `RegularTriangulationCellBase_3`. It has the default value `Regular_triangulation_cell_base_3<RT>`.

Is model of
  `RegularTriangulationCellBaseWithWeightedCircumcenter_3`

See also
  `CGAL::Triangulation_cell_base_3`
  `CGAL::Triangulation_cell_base_with_info_3`
  `CGAL::Regular_triangulation_cell_base_3`

## Types
typedef Traits::Point_3 | Point_3
typedef Traits::Weighted_point_3 | Point

## Access function
As a model of the concept `RegularTriangulationCellBase_3`, `Regular_triangulation_cell_base_with_weighted_circumcenter_3` provides a `weighted_circumcenter()` member function. In this model, the `weighted_circumcenter()` member function returns the weighted circumcenter of the cell. This `Point_3` is computed using the `Construct_weighted_circumcenter_3` functor of the traits class when this function is first called and its value is stored. In the next calls, the cached value is returned. Note that the returned point has no weight.
const Point_3 & | weighted_circumcenter (const Traits &gt=Traits()) const
| Computes the weighted circumcenter of the tetrahedron, or retrieves it if it has already been computed.
void | swap (Regular_triangulation_cell_base_with_weighted_circumcenter_3 &other) noexcept
| Swaps the Regular_triangulation_cell_base_with_weighted_circumcenter_3 and `other`.

## Member Function Documentation

## ◆ swap()

template<typename Traits , typename Cb >

void CGAL::Regular_triangulation_cell_base_with_weighted_circumcenter_3< Traits, Cb >::swap | ( | Regular_triangulation_cell_base_with_weighted_circumcenter_3< Traits, Cb > & | other | ) |
| noexcept

Swaps the Regular_triangulation_cell_base_with_weighted_circumcenter_3 and `other`.

This function should be preferred to an assignment or the copy constructor if `other` is deleted thereafter.

## ◆ weighted_circumcenter()

template<typename Traits , typename Cb >

const Point_3 & CGAL::Regular_triangulation_cell_base_with_weighted_circumcenter_3< Traits, Cb >::weighted_circumcenter | ( | const Traits & | gt = `Traits()` | ) | const

Computes the weighted circumcenter of the tetrahedron, or retrieves it if it has already been computed.

The returned point has no weight.